#include "EstimatedCameraPath.h"


namespace syb3r {
namespace data {

void EstimatedCameraPath::add(const Camera &camera, unsigned refIdx)
{
    if (m_cameras.find(refIdx) != m_cameras.end())
        throw std::runtime_error("A camera for that ref idx is already in the estimated path!");
    
    m_cameras.insert(std::pair<unsigned, Camera>(refIdx, camera));
}

}
}