#ifndef ESTIMATEDCAMERAPATH_H
#define ESTIMATEDCAMERAPATH_H

#include "Camera.h"

#include <map>

namespace syb3r {
namespace data {

class EstimatedCameraPath
{
    public:
        inline const std::map<unsigned, Camera> &getCameras() const { return m_cameras; }
        void add(const Camera &camera, unsigned refIdx);
    protected:
        std::map<unsigned, Camera> m_cameras;
};

}
}


#endif // ESTIMATEDCAMERAPATH_H
