#include "ShellExec.h"

#include <stdexcept>
#include <malloc.h>

namespace syb3r {
namespace tools {

bool ShellExec::run(const char *cmd)
{
    m_handle = popen(cmd, "r");
    if (!m_handle)
        throw std::runtime_error("Could not launch shell cmd!");

    size_t len = 0;
    char *lineBuf = nullptr;
    try {
        while (getline(&lineBuf, &len, m_handle) != -1) {
            parseLine(lineBuf);
        }
    } catch (...) {
        if (lineBuf)
            free(lineBuf);
        pclose(m_handle);
        throw;
    }
    if (lineBuf)
        free(lineBuf);

    const int ret = pclose(m_handle);
    return parseReturnCode(ret);
}

void ShellExec::parseLine(const char *)
{

}

bool ShellExec::parseReturnCode(int ret)
{
    return ret == 0;
}

}
}