#include "RenderJob.h"

#include <sstream>

namespace syb3r {
namespace synthesis {

bool RenderJob::render(const std::string &blendFile, const std::string &scriptFile)
{
    m_log.clear();

    std::stringstream command;
    command << blenderCmd << " -b " << blendFile << " -P " << scriptFile;

    return run(command.str().c_str());
}

void RenderJob::parseLine(const char *line)
{
    m_log.push_back(line);
}


}
}