#ifndef RENDERJOB_H
#define RENDERJOB_H

#include <syb3r/tools/ShellExec.h>

#include <vector>
#include <string>

namespace syb3r {
namespace synthesis {

class RenderJob : protected tools::ShellExec
{
    public:
        std::string blenderCmd = "blender";

        bool render(const std::string &blendFile, const std::string &scriptFile);
    protected:
        std::vector<std::string> m_log;

        virtual void parseLine(const char *line);
};

}
}

#endif // RENDERJOB_H
