#include <boost/test/unit_test.hpp>

#include <boost/test/floating_point_comparison.hpp>

#include <syb3r/models/CameraResponseCurve.h>

#include <random>

#include <iomanip>
#include <iostream>
/*

BOOST_AUTO_TEST_CASE(testCameraResponseCurve)
{
    std::default_random_engine generator(133700);
    std::uniform_real_distribution<float> distribution(0.0f, 1.0f);
    std::normal_distribution<float> noise(0.0f, 1.0f);

    const unsigned ldrRange = 256;

    float trueCurve[ldrRange];
    for (unsigned i = 0; i < ldrRange; i++) {
        float ldr = (i + 0.5f) / ldrRange;
        float hdr = -ldr / (ldr - 1.0f);
        trueCurve[i] = hdr;
    }

    std::vector<float> irradiances;
    irradiances.resize(500);
    for (unsigned i = 0; i < irradiances.size(); i++) {
        if (distribution(generator) < 0.8f)
            irradiances[i] = distribution(generator) * 0.5f;
        else
            irradiances[i] = distribution(generator) * 15.0f;
    }

    std::vector<float> exposures;
    for (float f = 0.25f; f < 16.0f; f*=1.3f)
        exposures.push_back(f);

    std::vector<unsigned> hist;
    hist.resize(ldrRange);

    std::vector<unsigned> values;
    for (unsigned i = 0; i < exposures.size(); i++) {
        for (unsigned j = 0; j < irradiances.size(); j++) {
            float hdr = irradiances[j] * exposures[i];
           // hdr += noise(generator) * 0.1f;

            hdr = std::max(hdr, 0.0f);

            float ldr = hdr / (1.0f + hdr);
            values.push_back(std::min<int>(ldrRange-1, ldr * ldrRange));
            hist[std::min<int>(ldrRange-1, ldr * ldrRange)]++;
        }
    }

    syb3r::math::CameraResponseCurve<ldrRange> curve;
    syb3r::math::computeCameraResponseFromMultipleExposures(values, exposures, 1.0f, curve);

    for (unsigned i = 0; i < ldrRange; i++) {
        std::cout << curve.ldrToHdr(i) << std::endl;
        std::cout << "               " << trueCurve[i] << std::endl;
        std::cout << "                                  " << hist[i] << std::endl;
    }

}
*/