#include "HelmertTransformation.h"

namespace syb3r {
namespace math {

template Eigen::Matrix<float, 4, 4> computeHelmertTransformation<float>(const Eigen::Matrix<float, 3, 1> *src, const Eigen::Matrix<float, 3, 1> *dst, unsigned count);
template Eigen::Matrix<double, 4, 4> computeHelmertTransformation<double>(const Eigen::Matrix<double, 3, 1> *src, const Eigen::Matrix<double, 3, 1> *dst, unsigned count);

}
}