#include "CPUStopWatch.h"

namespace syb3r {
namespace tools {

CPUStopWatch::CPUStopWatch()
{
    start();
}


void CPUStopWatch::start()
{
    m_start = std::chrono::steady_clock::now();
}

uint64_t CPUStopWatch::getNanoseconds()
{
    auto stop = std::chrono::steady_clock::now();

    std::chrono::nanoseconds diff = stop - m_start;
    return diff.count();
}

}
}